stan-0.2.0.0: Haskell STatic ANalyser

Copyright | (c) 2020 Kowainik
License | MPL-2.0
Maintainer | Kowainik <xrom.xkov@gmail.com>
Safe Haskell | None
Language | Haskell2010

Stan.Analysis

Description

Static analysis of all HIE files.

Synopsis

- data Analysis = Analysis {
  - analysisModulesNum :: !Int
  - analysisLinesOfCode :: !Int
  - analysisUsedExtensions :: !(Set OnOffExtension, Set SafeHaskellExtension)
  - analysisInspections :: !(HashSet (Id Inspection))
  - analysisObservations :: !Observations
  - analysisIgnoredObservations :: !Observations
  - analysisFileMap :: !FileMap
  }
- runAnalysis :: Map FilePath (Either ExtensionsError ParsedExtensions) -> HashMap FilePath (HashSet (Id Inspection)) -> [Id Observation] -> [HieFile] -> Analysis

# Documentation

data Analysis #

This data type stores all information collected during static analysis.

Constructors

Analysis |
Fields analysisModulesNum :: !Int analysisLinesOfCode :: !Int analysisUsedExtensions :: !(Set OnOffExtension, Set SafeHaskellExtension) analysisInspections :: !(HashSet (Id Inspection)) analysisObservations :: !Observations analysisIgnoredObservations :: !Observations analysisFileMap :: !FileMap

#### Instances

Instances details

Show Analysis # |
Instance details Defined in Stan.Analysis Methods showsPrec :: Int -> Analysis -> ShowS # show :: Analysis -> String # showList :: [Analysis] -> ShowS #
ToJSON Analysis # |
Instance details Defined in Stan.Analysis Methods toJSON :: Analysis -> Value #

runAnalysis #

Arguments

:: Map FilePath (Either ExtensionsError ParsedExtensions) |
-> HashMap FilePath (HashSet (Id Inspection)) |
-> [Id Observation] | List of to-be-ignored Observations.
-> [HieFile] |
-> Analysis |

Perform static analysis of given `HieFile`.